	include	exec/types.i
	include	exec/nodes.i

CIRRUSNAME	MACRO
		dc.b	'CirrusGD542X'
		ENDM

***********************************************************
MISCOUTPUTR	EQU	$3CC	;
MISCOUTPUTW	EQU	$3C2	;
INPUTSTATUS0	EQU	$3C2	;
INPUTSTATUS1	EQU	$3DA	;
FEATURECONTROLR	EQU	$3CA	;
FEATURECONTROLW	EQU	$3DA	;
VIDEOSYSENABLE	EQU	$3C3	; $46E8
DISPMODECONTROL	EQU	$3D8	;
PALETTEADDRESS	EQU	$3C8	;
PALETTEDATA	EQU	$3C9	;
ATNTMODECONTROL	EQU	$3DE	;
HERCULESCOMPAT	EQU	$3BF	;
***********************************************************

RESERVEDMEMORY	EQU	10*1024+2*1024+64

***********************************************************
TSI	EQU	$3C4	;
TSD	EQU	$3C5	;
***********************************************************
	ENUM
	EITEM	TS_SynchronousReset
	EITEM	TS_TSMode
	EITEM	TS_WritePlaneMask
	EITEM	TS_FontSelect
	EITEM	TS_MemoryMode
	EITEM	TS_Dummy1
	EITEM	TS_UnlockAllExtensions
	EITEM	TS_ExtendedSequencerMode
	EITEM	TS_EEPROMControl
	EITEM	TS_ScratchPad0
	EITEM	TS_ScratchPad1
	EITEM	TS_VCLK0Numerator
	EITEM	TS_VCLK1Numerator
	EITEM	TS_VCLK2Numerator
	EITEM	TS_VCLK3Numerator
	EITEM	TS_DRAMControl
	EITEM	TS_GraphicsCursorXPosition
	EITEM	TS_GraphicsCursorYPosition
	EITEM	TS_GraphicsCursorAttributes
	EITEM	TS_GraphicsCursorPattern
	EITEM	TS_ScratchPad2
	EITEM	TS_ScratchPad3
	EITEM	TS_PerformanceTuning
	EITEM	TS_ConfigReadback
	EITEM	TS_SignatureGeneratorControl
	EITEM	TS_SignatureGeneratorResultLow
	EITEM	TS_SignatureGeneratorResultHigh
	EITEM	TS_VCLK0Denominator
	EITEM	TS_VCLK1Denominator
	EITEM	TS_VCLK2Denominator
	EITEM	TS_VCLK3Denominator
	EITEM	TS_MCLKSelect

SetTS	MACRO
	move.b	#\2,TSI(a0)
	move.b	\1,TSD(a0)
	ENDM

***********************************************************
GDCI	EQU	$3CE	;
GDCD	EQU	$3CF	;
***********************************************************
	ENUM
	EITEM	GDC_SetReset
	EITEM	GDC_EnableSetReset
	EITEM	GDC_ColorCompare
	EITEM	GDC_DataRotateFunctionSelect
	EITEM	GDC_ReadPlaneSelect
	EITEM	GDC_GDCMode
	EITEM	GDC_Miscellaneous
	EITEM	GDC_ColorCare
	EITEM	GDC_BitMask
	EITEM	GDC_Offset0
	EITEM	GDC_Offset1
	EITEM	GDC_GDCModeExtensions
	EITEM	GDC_ColorKeyCompare
	EITEM	GDC_ColorKeyCompareMask
	EITEM	GDC_MiscellaneousControl
	ENUM	$10
	EITEM	GDC_PixelBgColorHigh
	EITEM	GDC_PixelFgColorHigh
	ENUM	$20
	EITEM	GDC_BLTWidthLow
	EITEM	GDC_BLTWidthHigh
	EITEM	GDC_BLTHeightLow
	EITEM	GDC_BLTHeightHigh
	EITEM	GDC_BLTDstPitchLow
	EITEM	GDC_BLTDstPitchHigh
	EITEM	GDC_BLTSrcPitchLow
	EITEM	GDC_BLTSrcPitchHigh
	EITEM	GDC_BLTDstStartLow
	EITEM	GDC_BLTDstStartMiddle
	EITEM	GDC_BLTDstStartHigh
	EITEM	GDC_Dummy1
	EITEM	GDC_BLTSrcStartLow
	EITEM	GDC_BLTSrcStartMiddle
	EITEM	GDC_BLTSrcStartHigh
	EITEM	GDC_Dummy2
	EITEM	GDC_BLTMode
	EITEM	GDC_BLTStartStatus
	EITEM	GDC_BLTRasterOperation
	EITEM	GDC_Dummy3
	EITEM	GDC_BLTTranspColorLow
	EITEM	GDC_BLTTranspColorHigh
	EITEM	GDC_Dummy4
	EITEM	GDC_Dummy5
	EITEM	GDC_BLTTranspColorMaskLow
	EITEM	GDC_BLTTranspColorMaskHigh

MAX_BLTWIDTH	EQU	2044
MAX_BLTHEIGHT	EQU	1024

SetGDC	MACRO
	move.b	#\2,GDCI(a0)
	move.b	\1,GDCD(a0)
	ENDM


SetBLTSrcStart	MACRO	Address, RegisterBase
	move.b	#GDC_BLTSrcStartLow,GDCI(\2)
	move.b	\1,GDCD(\2)
	lsr.w	#8,\1
	move.b	#GDC_BLTSrcStartMiddle,GDCI(\2)
	move.b	\1,GDCD(\2)
	swap	\1
	andi.b	#$1F,\1
	move.b	#GDC_BLTSrcStartHigh,GDCI(\2)
	move.b	\1,GDCD(\2)
	ENDM

SetBLTDstStart	MACRO	Address, RegisterBase
	move.b	#GDC_BLTDstStartLow,GDCI(\2)
	move.b	\1,GDCD(\2)
	lsr.w	#8,\1
	move.b	#GDC_BLTDstStartMiddle,GDCI(\2)
	move.b	\1,GDCD(\2)
	swap	\1
	andi.b	#$1F,\1
	move.b	#GDC_BLTDstStartHigh,GDCI(\2)
	move.b	\1,GDCD(\2)
	ENDM

SetBLTSrcPitch	MACRO	Pitch, RegisterBase
	move.b	#GDC_BLTSrcPitchLow,GDCI(\2)
	move.b	\1,GDCD(\2)
	lsr.w	#8,\1
	andi.b	#15,\1
	move.b	#GDC_BLTSrcPitchHigh,GDCI(\2)
	move.b	\1,GDCD(\2)
	ENDM

SetBLTDstPitch	MACRO	Pitch, RegisterBase
	move.b	#GDC_BLTDstPitchLow,GDCI(\2)
	move.b	\1,GDCD(\2)
	lsr.w	#8,\1
	andi.b	#15,\1
	move.b	#GDC_BLTDstPitchHigh,GDCI(\2)
	move.b	\1,GDCD(\2)
	ENDM

SetBLTWidth	MACRO	Width, RegisterBase
	subq.w	#1,\1
	move.b	#GDC_BLTWidthLow,GDCI(\2)
	move.b	\1,GDCD(\2)
	lsr.w	#8,\1
	andi.b	#7,\1
	move.b	#GDC_BLTWidthHigh,GDCI(\2)
	move.b	\1,GDCD(\2)
	ENDM

SetBLTHeight	MACRO	Height, RegisterBase
	subq.w	#1,\1
	move.b	#GDC_BLTHeightLow,GDCI(\2)
	move.b	\1,GDCD(\2)
	lsr.w	#8,\1
	andi.b	#3,\1
	move.b	#GDC_BLTHeightHigh,GDCI(\2)
	move.b	\1,GDCD(\2)
	ENDM

SetBLTROP	MACRO	ROP, RegisterBase
	move.w	#(GDC_BLTRasterOperation<<8)|\1,GDCI(\2)
	ENDM

ROP_FALSE	EQU	$00
ROP_NOR		EQU	$90
ROP_ONLYDST	EQU	$50
ROP_NOTSRC	EQU	$d0
ROP_ONLYSRC	EQU	$09
ROP_NOTDST	EQU	$0b
ROP_EOR		EQU	$59
ROP_NAND	EQU	$da
ROP_AND		EQU	$05
ROP_NEOR	EQU	$95
ROP_DST		EQU	$06
ROP_NOTONLYSRC	EQU	$d6
ROP_SRC		EQU	$0d
ROP_NOTONLYDST	EQU	$ad
ROP_OR		EQU	$6d
ROP_TRUE	EQU	$0e

***********************************************************
ATCI	EQU	$3C0	;
ATCR	EQU	$3C1	;
ATCD	EQU	ATCI
***********************************************************
	ENUM
	EITEM	ATC_PaletteRAM0
	EITEM	ATC_PaletteRAM1
	EITEM	ATC_PaletteRAM2
	EITEM	ATC_PaletteRAM3
	EITEM	ATC_PaletteRAM4
	EITEM	ATC_PaletteRAM5
	EITEM	ATC_PaletteRAM6
	EITEM	ATC_PaletteRAM7
	EITEM	ATC_PaletteRAM8
	EITEM	ATC_PaletteRAM9
	EITEM	ATC_PaletteRAMa
	EITEM	ATC_PaletteRAMb
	EITEM	ATC_PaletteRAMc
	EITEM	ATC_PaletteRAMd
	EITEM	ATC_PaletteRAMe
	EITEM	ATC_PaletteRAMf
	EITEM	ATC_ModeControl
	EITEM	ATC_OverscanColor
	EITEM	ATC_ColorPlaneEnable
	EITEM	ATC_HorizontalPixelPanning
	EITEM	ATC_ColorSelect

	BITDEF	ATC,PaletteRAMAddressSource,5

ResetATC	MACRO
		tst.b	INPUTSTATUS1(a0)	; set ATC to indexed mode
		nop
		ENDM

SetATC	MACRO
	move.b	#(\2|ATCF_PaletteRAMAddressSource),ATCI(a0)
	move.b	\1,ATCD(a0)
	ENDM

***********************************************************
CRTCI	EQU	$3D4	;
CRTCD	EQU	$3D5	;
***********************************************************
	ENUM
	EITEM	CRTC_HorizontalTotal
	EITEM	CRTC_HorizontalDisplayEnd
	EITEM	CRTC_HorizontalBlankStart
	EITEM	CRTC_HorizontalBlankEnd
	EITEM	CRTC_HorizontalSyncStart
	EITEM	CRTC_HorizontalSyncEnd
	EITEM	CRTC_VerticalTotal
	EITEM	CRTC_OverflowLow
	EITEM	CRTC_PresetRowScan
	EITEM	CRTC_MaximumRowAddress
	EITEM	CRTC_CursorStartRowAddress
	EITEM	CRTC_CursorEndRowAddress
	EITEM	CRTC_LinearStartingAddressMiddle
	EITEM	CRTC_LinearStartingAddressLow
	EITEM	CRTC_CursorAddressMiddle
	EITEM	CRTC_CursorAddressLow
	EITEM	CRTC_VerticalSyncStart
	EITEM	CRTC_VerticalSyncEnd
	EITEM	CRTC_VerticalDisplayEnd
	EITEM	CRTC_RowOffset
	EITEM	CRTC_UnderlineRowAddress
	EITEM	CRTC_VerticalBlankStart
	EITEM	CRTC_VerticalBlankEnd
	EITEM	CRTC_CRTCMode
	EITEM	CRTC_LineCompare
	EITEM	CRTC_InterlaceEnd
	EITEM	CRTC_MiscellaneousControl
	EITEM	CRTC_ExtendedDisplayControls
	ENUM	$22
	EITEM	CRTC_DataLatchesReadback
	EITEM	CRTC_Dummy1
	EITEM	CRTC_ATCToggleReadback
	EITEM	CRTC_PartStatus
	EITEM	CRTC_ATCIndexReadback
	EITEM	CRTC_ID

CL_GD5420	EQU	%10001000
CL_GD5422	EQU	%10001100
CL_GD5424	EQU	%10010100
CL_GD5426	EQU	%10010000
CL_GD5428	EQU	%10011000
CL_GD5429	EQU	%10011100
CL_GD54xx	EQU	%11111100

SetCRTC	MACRO
	move.b	#\2,CRTCI(a0)
	move.b	\1,CRTCD(a0)
	ENDM
