#include <intuition/screens.h>
#include <graphics/rastport.h>
#include <graphics/gfxmacros.h>

#include <proto/exec.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/Picasso96.h>

UWORD Muster[]= { 0x00ff };

#define	WIDTH		4*32+8*32
#define	HEIGHT	32+32+64+32
#define	DEPTH		8

char	ScreenTitle[] = "Picasso96 BlitTemplate Test";
char	Template[] = "Width=W/N,Height=H/N,Depth=D/N";
LONG	Array[] = { 0, 0, 0 };
WORD	Pens[] = {~0};

void Render(struct RastPort *rp, WORD x, WORD y, UBYTE mask)
{
	rp->Mask = 0xff;

	SetDrMd(rp, JAM2);
	SetAPen(rp, 7);
	RectFill(rp, x+0*32, y+4, x+31+7*32, y+12-1);

	y += rp->Font->tf_Baseline;

	SetAPen(rp, 1);
	SetBPen(rp, 2);

	rp->Mask = mask;

	SetDrMd(rp, JAM1);
	Move(rp, x+0*32, y);
	Text(rp, "Hop", 3);
	SetDrMd(rp, JAM1|INVERSVID);
	Move(rp, x+1*32, y);
	Text(rp, "Hop", 3);
	SetDrMd(rp, JAM1|COMPLEMENT);
	Move(rp, x+2*32, y);
	Text(rp, "Hop", 3);
	SetDrMd(rp, JAM1|INVERSVID|COMPLEMENT);
	Move(rp, x+3*32, y);
	Text(rp, "Hop", 3);
	SetDrMd(rp, JAM2);
	Move(rp, x+4*32, y);
	Text(rp, "Hop", 3);
	SetDrMd(rp, JAM2|INVERSVID);
	Move(rp, x+5*32, y);
	Text(rp, "Hop", 3);
	SetDrMd(rp, JAM2|COMPLEMENT);
	Move(rp, x+6*32, y);
	Text(rp, "Hop", 3);
	SetDrMd(rp, JAM2|INVERSVID|COMPLEMENT);
	Move(rp, x+7*32, y);
	Text(rp, "Hop", 3);

	rp->Mask = 0xff;
}

main(void)
{
	ULONG	DisplayID;

	if(INVALID_ID != (DisplayID = p96RequestModeIDTags(TAG_DONE))){
		struct Screen		*sc;

		if(sc=OpenScreenTags(NULL,
									SA_DisplayID,DisplayID,SA_Depth,8,SA_Width,640,SA_Height,480,SA_Pens,Pens,SA_FullPalette,TRUE,SA_Title,(ULONG)ScreenTitle,TAG_DONE)){
			struct BitMap		*bm;

			/* width of bitmap doesn't allow it to be put on the board */ 

			if(bm = AllocBitMap(4100,16,8,BMF_CLEAR,sc->RastPort.BitMap)){
				struct Window		*wd;

				if(wd=OpenWindowTags(NULL,WA_Left,0,WA_Width,WIDTH,WA_Height,HEIGHT,
											WA_DragBar,TRUE,WA_DragBar,TRUE,WA_Activate,TRUE,WA_CloseGadget,TRUE,WA_IDCMP,IDCMP_CLOSEWINDOW|IDCMP_RAWKEY,WA_CustomScreen,sc,WA_Title,(ULONG)ScreenTitle,TAG_DONE)){
					struct RastPort	*rp, prp;
					struct Message		*msg;

					rp = wd->RPort;

					prp = *rp;

					prp.Layer = NULL;
					prp.BitMap = bm;

					Render(&prp, 0, 0, 0x05);
					BltBitMapRastPort(bm, 0, 0, rp, 2*32+12, 80, 8*32, 16, 0xc0);

					BltBitMap(bm, 0, 0, bm, 0, 0, 8*32, 16, 0x00, 0xff, NULL);
					Render(&prp, 0, 0, 0xff);
					BltBitMapRastPort(bm, 0, 0, rp, 2*32+12, 48, 8*32, 16, 0xc0);

					Render(rp, 2*32+12, 32, 0xff);

					Render(rp, 2*32+12, 64, 0x05);

					SetDrMd(rp, JAM1);
					SetAPen(rp, 1);
					SetBPen(rp, 0);

					Move(rp,12,32+16);
					Text(rp,"No Mask",7);
					Move(rp,12,2*32+16);
					Text(rp,"Mask $5",7);

					Move(rp,12+3*32,73+32);
					Text(rp,"INV",3);
					Move(rp,12+5*32,73+32);
					Text(rp,"INV",3);
					Move(rp,12+7*32,73+32);
					Text(rp,"INV",3);
					Move(rp,12+9*32,73+32);
					Text(rp,"INV",3);

					Move(rp,12+4*32+16,83+32);
					Text(rp,"COMP",4);
					Move(rp,12+8*32+16,83+32);
					Text(rp,"COMP",4);

					Move(rp,4*32,92+32);
					Text(rp,"JAM1",4);
					Move(rp,8*32,92+32);
					Text(rp,"JAM2",4);

					Move(rp,10*32+16,32+8);
					Text(rp,"CARD",4);

					Move(rp,10*32+16,32+8+16);
					Text(rp,"RAM",3);

					Move(rp,10*32+16,32+8+32);
					Text(rp,"CARD",4);

					Move(rp,10*32+16,32+8+16+32);
					Text(rp,"RAM",3);

					WaitPort(wd->UserPort);
					
					Forbid();
					while(msg = GetMsg(wd->UserPort)) ReplyMsg(msg);
					Permit();

					CloseWindow(wd);
				}
				FreeBitMap(bm);
			}
			CloseScreen(sc);
		}
	}
}
